﻿using System;
using System.Collections.ObjectModel;
using System.Linq;
using System.Net;
using System.Xml.Linq;
using System.Windows.Controls;

namespace CoverFlowFlickrExample
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            WebClient webClient = new WebClient();

            webClient.DownloadStringCompleted += this.OnDownloadStringCompleted;
            webClient.DownloadStringAsync(new Uri(@"http://api.flickr.com/services/feeds/photos_public.gne?id=57287444@N02&lang=en-us&format=rss_2", UriKind.Absolute)); 
        }


        private void OnDownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            ObservableCollection<AssetImageSummaryII> flickerImagesCollection = new ObservableCollection<AssetImageSummaryII>();

            XDocument feed = XDocument.Parse(e.Result);

            int i = 0;

            foreach (XElement entry in feed.Root.Elements(XName.Get("entry", "http://www.w3.org/2005/Atom")))
            {
                string[] links = (from link in entry.Elements(XName.Get("link", "http://www.w3.org/2005/Atom"))
                                  where string.Compare(link.Attribute(XName.Get("rel")).Value, "enclosure") == 0
                                  select link.Attribute(XName.Get("href")).Value).ToArray<string>();
                if (links.Length > 0)
                {
                    flickerImagesCollection.Add(new AssetImageSummaryII(links[0], links[0]));
                    i++;
                    if (i == 7)
                        break;

                }
            }

            this.coverFlow.ItemsSource = flickerImagesCollection;  
        }

        public class AssetImageSummaryII
        {
            public Uri TheImage { get; set; }
            public string Title { get; set; }

            public AssetImageSummaryII(string imageURL, string title)
            {
                TheImage = new Uri(imageURL, UriKind.Absolute);
                Title = title;
            }
        } 
    }
}
